/*
 * Copyright (C) 2009 The ExTeX Group and individual authors listed below
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

package org.extex.builder.latex.artifact.latex.macro;

import java.io.File;
import java.io.IOException;
import java.util.logging.Logger;

import org.extex.builder.latex.DependencyNet;
import org.extex.builder.latex.Message;
import org.extex.builder.latex.artifact.Artifact;
import org.extex.builder.latex.artifact.latex.LatexReader;
import org.extex.builder.latex.artifact.latex.MacroWithArgs;

/**
 * This class implements a handler for <code>&#x5c;usepackage</code>.
 * 
 * @author <a href="mailto:gene@gerd-neugebauer.de">Gerd Neugebauer</a>
 * @version $Revision$
 */
public final class UsePackage extends MacroWithArgs {

    /**
     * The field <tt>PACKAGES</tt> contains the known packages.
     */
    private static final String[] PACKAGES = new String[]{//
            "12many", // 12many
                    "2in1", // ltxmisc
                    "2sidedoc", // relenc
                    "2up", // seminar
                    "3parttable", // ltxmisc
                    "8r", // psnfssx
                    "CV", // cv
                    "CoverPage", // coverpage
                    "ESIEEcv", // ESIEEcv
                    "HA-prosper", // HA-prosper
                    "HAPAggie", // HA-prosper/Styles/Aggie
                    "HAPFyma", // HA-prosper/Styles/Fyma
                    "HAPHA", // HA-prosper/Styles/HA
                    "HAPLakar", // HA-prosper/Styles/Lakar
                    "HAPTCS", // HA-prosper/Styles/TCS
                    "HAPTCSTealBlue", // HA-prosper/Styles/TCS
                    "HAPTCSgrad", // HA-prosper/Styles/TCS
                    "HAPTycja", // HA-prosper/Styles/Tycja
                    "HAPcapsules", // HA-prosper/Styles/Capsules
                    "HAPciment", // HA-prosper/Styles/Ciment
                    "HAPsimple", // HA-prosper/Styles/Simple
                    "IEEEtrantools", // IEEEtran
                    "PPRalcatel", // prosper
                    "PPRalienglow", // prosper
                    "PPRautumn", // prosper
                    "PPRazure", // prosper
                    "PPRblends", // prosper
                    "PPRcapsules", // prosper
                    "PPRcontemporain", // prosper
                    "PPRcorners", // prosper
                    "PPRdarkblue", // prosper
                    "PPRdefault", // prosper
                    "PPRframes", // prosper
                    "PPRfyma", // prosper
                    "PPRgyom", // prosper
                    "PPRlignesbleues", // prosper
                    "PPRmancini", // prosper
                    "PPRnuancegris", // prosper
                    "PPRprettybox", // prosper
                    "PPRrico", // prosper
                    "PPRserpaggi", // prosper
                    "PPRthomasd", // prosper
                    "PPRtroispoints", // prosper
                    "PPRwhitecross", // prosper
                    "PPRwinter", // prosper
                    "PPRwj", // prosper
                    "SIunits", // SIunits
                    "Sw2Rus", // sciwordconv
                    "Tabbing", // Tabbing
                    "a0size", // a0poster
                    "a4", // ntgclass
                    "a4wide", // ltxmisc
                    "a5comb", // ltxmisc
                    "aastex", // aastex
                    "abstract", // abstract
                    "accents", // bezos
                    "achemso", // achemso
                    "acromake", // ltxmisc
                    "acronym", // acronym
                    "addrset", // newlfm
                    "adiseal", // cdpbundl
                    "adrlist", // adrlist
                    "advdate", // ltxmisc
                    "ae", // ae
                    "aecompl", // ae
                    "aeguill", // aeguill
                    "aer", // economic
                    "aertt", // economic
                    "afoot", // ledmac
                    "afterpackage", // ncctools
                    "afterpage", // tools
                    "aguplus", // aguplus
                    "aicv1", // iso10303
                    "albertus", // pclnfss
                    "alg", // alg
                    "algc", // algorithmicx
                    "algcompatible", // algorithmicx
                    "algmatlab", // algorithmicx
                    "algorithm", // algorithms
                    "algorithm2e", // algorithm2e
                    "algorithmic", // algorithms
                    "algorithmicx", // algorithmicx
                    "algpascal", // algorithmicx
                    "algpseudocode", // algorithmicx
                    "aliascnt", // oberdiek
                    "allauncl", // bookhands
                    "allcmin", // bookhands
                    "allegoth", // bookhands
                    "allhmin", // bookhands
                    "allhuncl", // bookhands
                    "allimaj", // bookhands
                    "allimin", // bookhands
                    "allpgoth", // bookhands
                    "allrtnd", // bookhands
                    "allrunes", // allrunes
                    "allrust", // bookhands
                    "allsqrc", // bookhands
                    "alltgoth", // bookhands
                    "alltt", // base
                    "alluncl", // bookhands
                    "alnumsec", // alnumsec
                    "alphanum", // jura
                    "altfont", // altfont
                    "ams-mdbch", // arev
                    "amsbooka", // amscls
                    "amsbsy", // amsmath
                    "amscd", // amsmath
                    "amsfonts", // amsfonts
                    "amsgen", // amsmath
                    "amsmath", // amsmath
                    "amsmidx", // amscls
                    "amsopn", // amsmath
                    "amsrbeta", // amscls
                    "amsrefs", // amscls
                    "amssymb", // amsfonts
                    "amstex", // amsmath
                    "amstext", // amsmath
                    "amsthm", // amscls
                    "amsxtra", // amsmath
                    "anonchap", // ltxmisc
                    "answers", // answers
                    "antcmlgc", // cm-lgc
                    "antolive", // pclnfss
                    "antree", // williams
                    "anttor", // antt
                    "antyktor", // antt
                    "anysize", // anysize
                    "apacite", // apacite
                    "apl", // apl
                    "aplstyle", // apl
                    "appendix", // appendix
                    "apv12", // iso10303
                    "ar", // ar
                    "arabicfront", // bezos
                    "aramaic", // archaic
                    "arcs", // arcs
                    "arev", // arev
                    "arevmath", // arev
                    "arevtext", // arev
                    "arial", // pclnfss
                    "array", // tools
                    "article", // base
                    "arydshln", // arydshln
                    "asaesub", // asaetr
                    "asaetr", // asaetr
                    "ascii", // ascii
                    "askinclude", // ltxmisc
                    "askincv1", // iso
                    "at", // mdwtools
                    "atsv11", // iso10303
                    "attachfile", // attachfile
                    "attachfile2", // oberdiek
                    "auncial", // bookhands
                    "aurical", // aurical
                    "authblk", // preprint
                    "authoraftertitle", // ltxmisc
                    "authorindex", // authorindex
                    "autind", // index
                    "auto-pst-pdf", // auto-pst-pdf
                    "autofe", // ucs
                    "autofilo", // calendar
                    "automata", // texpower
                    "autopagewidth", // extsizes
                    "autotab", // autotab
                    "auxhook", // oberdiek
                    "avant", // psnfss
                    "babelbib", // babelbib
                    "babelfr", // frenchle
                    "background", // ppower4
                    "backref", // hyperref
                    "balance", // preprint
                    "bar", // misc209
                    "barcodes", // barcode2
                    "barddoc", // bardiag
                    "bardiag", // bardiag
                    "basker", // psnfssx
                    "bbding", // bbding
                    "bbm", // bbm
                    "bbold", // bbold
                    "bdfchess", // chess
                    "beamerarticle", // beamer
                    "beamerbasearticle", // beamer
                    "beamerbaseauxtemplates", // beamer
                    "beamerbaseboxes", // beamer
                    "beamerbasecolor", // beamer
                    "beamerbasecompatibility", // beamer
                    "beamerbasedecode", // beamer
                    "beamerbaseexercise", // beamer
                    "beamerbasefont", // beamer
                    "beamerbaseframe", // beamer
                    "beamerbaseframecomponents", // beamer
                    "beamerbaseframesize", // beamer
                    "beamerbaselocalstructure", // beamer
                    "beamerbasemisc", // beamer
                    "beamerbasemodes", // beamer
                    "beamerbasenavigation", // beamer
                    "beamerbasenotes", // beamer
                    "beamerbaseoptions", // beamer
                    "beamerbaseoverlay", // beamer
                    "beamerbasercs", // beamer
                    "beamerbasesection", // beamer
                    "beamerbasetemplates", // beamer
                    "beamerbasethemes", // beamer
                    "beamerbasetheorems", // beamer
                    "beamerbasetitle", // beamer
                    "beamerbasetoc", // beamer
                    "beamerbasetwoscreens", // beamer
                    "beamerbaseverbatim", // beamer
                    "beamercolorthemealbatross", // beamer/themes/color
                    "beamercolorthemebeaver", // beamer/themes/color
                    "beamercolorthemebeetle", // beamer/themes/color
                    "beamercolorthemecrane", // beamer/themes/color
                    "beamercolorthemedefault", // beamer/themes/color
                    "beamercolorthemedolphin", // beamer/themes/color
                    "beamercolorthemedove", // beamer/themes/color
                    "beamercolorthemefly", // beamer/themes/color
                    "beamercolorthemelily", // beamer/themes/color
                    "beamercolorthemeorchid", // beamer/themes/color
                    "beamercolorthemerose", // beamer/themes/color
                    "beamercolorthemeseagull", // beamer/themes/color
                    "beamercolorthemeseahorse", // beamer/themes/color
                    "beamercolorthemesidebartab", // beamer/themes/color
                    "beamercolorthemestructure", // beamer/themes/color
                    "beamercolorthemewhale", // beamer/themes/color
                    "beamercolorthemewolverine", // beamer/themes/color
                    "beamerfoils", // beamer/emulation
                    "beamerfontthemedefault", // beamer/themes/font
                    "beamerfontthemeprofessionalfonts", // beamer/themes/font
                    "beamerfontthemeserif", // beamer/themes/font
                    "beamerfontthemestructurebold", // beamer/themes/font
                    "beamerfontthemestructureitalicserif", // beamer/themes/font
                    "beamerfontthemestructuresmallcapsserif", // beamer/themes/font
                    "beamerinnerthemecircles", // beamer/themes/inner
                    "beamerinnerthemedefault", // beamer/themes/inner
                    "beamerinnerthemeinmargin", // beamer/themes/inner
                    "beamerinnerthemerectangles", // beamer/themes/inner
                    "beamerinnerthemerounded", // beamer/themes/inner
                    "beamerouterthemedefault", // beamer/themes/outer
                    "beamerouterthemeinfolines", // beamer/themes/outer
                    "beamerouterthememiniframes", // beamer/themes/outer
                    "beamerouterthemeshadow", // beamer/themes/outer
                    "beamerouterthemesidebar", // beamer/themes/outer
                    "beamerouterthemesmoothbars", // beamer/themes/outer
                    "beamerouterthemesmoothtree", // beamer/themes/outer
                    "beamerouterthemesplit", // beamer/themes/outer
                    "beamerouterthemetree", // beamer/themes/outer
                    "beamerprosper", // beamer/emulation
                    "beamerseminar", // beamer/emulation
                    "beamertexpower", // beamer/emulation
                    "beamerthemeAnnArbor", // beamer/themes/theme
                    "beamerthemeAntibes", // beamer/themes/theme
                    "beamerthemeBergen", // beamer/themes/theme
                    "beamerthemeBerkeley", // beamer/themes/theme
                    "beamerthemeBerlin", // beamer/themes/theme
                    "beamerthemeBoadilla", // beamer/themes/theme
                    "beamerthemeCambridgeUS", // beamer/themes/theme
                    "beamerthemeCopenhagen", // beamer/themes/theme
                    "beamerthemeDarmstadt", // beamer/themes/theme
                    "beamerthemeDresden", // beamer/themes/theme
                    "beamerthemeFrankfurt", // beamer/themes/theme
                    "beamerthemeGoettingen", // beamer/themes/theme
                    "beamerthemeHannover", // beamer/themes/theme
                    "beamerthemeIlmenau", // beamer/themes/theme
                    "beamerthemeJuanLesPins", // beamer/themes/theme
                    "beamerthemeLuebeck", // beamer/themes/theme
                    "beamerthemeMadrid", // beamer/themes/theme
                    "beamerthemeMalmoe", // beamer/themes/theme
                    "beamerthemeMarburg", // beamer/themes/theme
                    "beamerthemeMontpellier", // beamer/themes/theme
                    "beamerthemePaloAlto", // beamer/themes/theme
                    "beamerthemePittsburgh", // beamer/themes/theme
                    "beamerthemeRochester", // beamer/themes/theme
                    "beamerthemeSingapore", // beamer/themes/theme
                    "beamerthemeSzeged", // beamer/themes/theme
                    "beamerthemeWarsaw", // beamer/themes/theme
                    "beamerthemebars", // beamer/themes/theme/compatibility
                    "beamerthemeboxes", // beamer/themes/theme
                    "beamerthemeclassic", // beamer/themes/theme/compatibility
                    "beamerthemecompatibility", // beamer/themes/theme/compatibility
                    "beamerthemedefault", // beamer/themes/theme
                    "beamerthemelined", // beamer/themes/theme/compatibility
                    "beamerthemeplain", // beamer/themes/theme/compatibility
                    "beamerthemeshadow", // beamer/themes/theme/compatibility
                    "beamerthemesidebar", // beamer/themes/theme/compatibility
                    "beamerthemesplit", // beamer/themes/theme/compatibility
                    "beamerthemetree", // beamer/themes/theme/compatibility
                    "begriff", // begriff
                    "bembo", // psnfssx
                    "bera", // bera
                    "beramono", // bera
                    "berasans", // bera
                    "beraserif", // bera
                    "beton", // beton
                    "bez123", // bez123
                    "bezier", // base
                    "bg", // backgammon
                    "bibarts", // bibarts
                    "bibcheck", // ltxmisc
                    "bibentry", // natbib
                    "bibgerm", // germbib
                    "bibleref", // bibleref
                    "biblist", // biblist
                    "bibmods", // misc209
                    "bibref", // index
                    "bibtopic", // bibtopic
                    "bibunits", // bibunits
                    "bigdelim", // multirow
                    "bigfoot", // bigfoot
                    "bigstrut", // multirow
                    "binary", // SIunits
                    "binomexp", // binomexp
                    "biocon", // biocon
                    "biotex", // textopo
                    "bitfield", // bitfield
                    "bizcard", // bizcard
                    "bkltprnt", // booklet
                    "blindtext", // blindtext
                    "blkarray", // carlisle
                    "block", // ltxmisc
                    "bm", // tools
                    "bmpsize", // oberdiek
                    "bmpsize-base", // oberdiek
                    "board", // cheq
                    "boites", // boites
                    "boites_exemples", // boites
                    "bold-extra", // ltxmisc
                    "book", // base
                    "booklet", // booklet
                    "bookman", // psnfss
                    "booktabs", // booktabs
                    "bophook", // bophook
                    "boundbox", // sttools
                    "boxedminipage", // ltxmisc
                    "boxhandler", // boxhandler
                    "bpchem", // bpchem
                    "braille", // braille
                    "braket", // ltxmisc
                    "breakcites", // ltxmisc
                    "breakurl", // breakurl
                    "breqn", // breqn
                    "bsp", // umrand
                    "bussproofs", // bussproofs
                    "byname", // smartref
                    "bytefield", // bytefield
                    "calc", // tools
                    "calendar", // calendar
                    "calligra", // fundus
                    "calrsfs", // calrsfs
                    "camel", // camel
                    "cancel", // ltxmisc
                    "capt-of", // ltxmisc
                    "captcont", // captcont
                    "captdef", // ltxmisc
                    "caption", // caption
                    "caption2", // caption
                    "caption3", // caption
                    "carolmin", // bookhands
                    "cases", // ltxmisc
                    "casyltex", // casyl
                    "cc-cls", // computational-complexity
                    "cc2cite", // computational-complexity
                    "cc4amsart", // computational-complexity
                    "cc4apjrnl", // computational-complexity
                    "cc4elsart", // computational-complexity
                    "cc4jT", // computational-complexity
                    "cc4llncs", // computational-complexity
                    "cc4siamltex", // computational-complexity
                    "ccalgo", // computational-complexity
                    "ccaption", // ccaption
                    "ccaux", // computational-complexity
                    "cccite", // computational-complexity
                    "ccdbs", // computational-complexity
                    "ccfonts", // ccfonts
                    "cchess", // cchess
                    "cclayout", // computational-complexity
                    "ccproof", // computational-complexity
                    "ccqed", // computational-complexity
                    "ccreltx", // computational-complexity
                    "ccthm", // computational-complexity
                    "cd-cover", // cd-cover
                    "cdpaddon", // cdpbundl
                    "cellspace", // cellspace
                    "centernot", // oberdiek
                    "cgloss4e", // linguex
                    "cgomega", // pclnfss
                    "cgtimes", // pclnfss
                    "chancery", // psnfss
                    "changebar", // changebar
                    "chappg", // chappg
                    "chapterbib", // cite
                    "chapterfolder", // chapterfolder
                    "charter", // psnfss
                    "chbibref", // ltxmisc
                    "checkend", // bezos
                    "chemarr", // oberdiek
                    "chemarrow", // chemarrow
                    "chemcompounds", // chemcompounds
                    "chemcono", // chemcono
                    "cheq", // cheq
                    "cherokee", // cherokee
                    "chess", // chess
                    "chess-workshop-symbols", // skak
                    "chessboa", // chess
                    "chesskey", // chess
                    "chessmg", // chess
                    "china2e", // china2e
                    "chngcntr", // ltxmisc
                    "chngpage", // ltxmisc
                    "circ", // circ
                    "circle", // ltxmisc
                    "cite", // cite
                    "citeref", // citeref
                    "cje", // economic
                    "cjwmacro", // cjw
                    "cjwmath", // cjw
                    "cjwoutl", // cjw
                    "cjwplain", // cjw
                    "cjwresize", // cjw
                    "cjwunits", // cjw
                    "clarend", // pclnfss
                    "classlist", // oberdiek
                    "clefval", // clefval
                    "clock", // clock
                    "clrscode", // clrscode
                    "cmap", // cmap
                    "cmbright", // cmbright
                    "cmdtrack", // cmdtrack
                    "cmlgc", // cm-lgc
                    "cmll", // cmll
                    "cmmib57", // amsfonts
                    "cmsd", // cmsd
                    "cmtt", // mdwtools
                    "codep", // examplep
                    "codepage", // codepage
                    "collect", // sauerj
                    "colonequals", // oberdiek
                    "color", // graphics
                    "colorinfo", // colorinfo
                    "colortab", // colortab
                    "colortbl", // colortbl
                    "combinet", // combine
                    "combnat", // combine
                    "comma", // carlisle
                    "commath", // commath
                    "comment", // comment
                    "compactbib", // compactbib
                    "complexity", // complexity
                    "concmath", // concmath
                    "concrete", // ltxmisc
                    "contour", // contour
                    "cooking", // cooking
                    "cool", // cool
                    "coollist", // coollist
                    "coolstr", // coolstr
                    "cooltooltips", // cooltooltips
                    "coordsys", // coordsys
                    "coptic", // cbcoptic
                    "coronet", // pclnfss
                    "count1to", // count1to
                    "courier", // psnfss
                    "couriers", // courier-scaled
                    "covington", // covington
                    "creatdtx", // makedtx
                    "createsudoku", // sudokubundle
                    "crop", // crop
                    "crossreference", // crossreference
                    "crosswrd", // crosswrd
                    "csquotes", // csquotes
                    "csvtools", // csvtools
                    "ctable", // ctable
                    "ctibmantra", // pecha
                    "cuisine", // cuisine
                    "currvita", // currvita
                    "cursor", // cursor
                    "curve2e", // curve2e
                    "curves", // curves
                    "curvesls", // curves
                    "cuted", // sttools
                    "cwpuzzle", // cwpuzzle
                    "cypriot", // archaic
                    "cyr", // fundus
                    "dashbox", // dashbox
                    "dashrule", // dashrule
                    "dateiliste", // dateiliste
                    "datenumber", // datenumber
                    "dates", // calendar
                    "datetime", // datetime
                    "dblfloatfix", // ltxmisc
                    "dblfnote", // yafoot
                    "dcolumn", // tools
                    "dcounter", // ncctools
                    "dcpic", // dcpic
                    "decimal", // decimal
                    "defpattern", // fp
                    "delarray", // tools
                    "deleq", // deleq
                    "denselists", // nih
                    "desclist", // ncctools
                    "diagnose", // diagnose
                    "dialog", // dialogl
                    "dialogl", // dialogl
                    "dichokey", // dichokey
                    "dictsym", // dictsym
                    "digiconfigs", // digiconfigs
                    "dinbrief", // dinbrief
                    "dingbat", // dingbat
                    "directory", // directory
                    "dk-apali", // dk-bib
                    "dk-bib", // dk-bib
                    "dnaseq", // dnaseq
                    "doafter", // mdwtools
                    "doc", // base
                    "docidx2e", // xdoc
                    "docindex", // xdoc
                    "docmfp", // docmfp
                    "docs", // revtex
                    "doipubmed", // doipubmed
                    "dotlessi", // bezos
                    "dotlessj", // carlisle
                    "dotseqn", // dotseqn
                    "dottex", // dottex
                    "dpfloat", // dpfloat
                    "draftcopy", // draftcopy
                    "draftwatermark", // draftwatermark
                    "dramatist", // dramatist
                    "drftcite", // cite
                    "drftcono", // chemcono
                    "dropping", // dropping
                    "dsfont", // doublestroke
                    "dtk", // dtk
                    "dtk-logo", // dtk
                    "dtk-pdf", // dtk
                    "dtklogos", // dtk
                    "dtx-attach", // oberdiek
                    "dvipaste", // export
                    "dvipscol", // oberdiek
                    "dyntree", // dyntree
                    "eCards", // eCards
                    "easy", // easy
                    "easybib", // easy
                    "easybmat", // easy
                    "easyeqn", // easy
                    "easymat", // easy
                    "easytable", // easy
                    "easyvector", // easy
                    "ebezier", // ebezier
                    "eclbip", // ecltree
                    "ecltree", // ecltree
                    "eco", // eco
                    "ecsubzcm", // relenc
                    "edcntwd0", // ednotes
                    "ednmath0", // lineno
                    "ednotes", // ednotes
                    "edtable", // lineno
                    "eemeir", // eemeir
                    "eepic", // eepic
                    "eepicemu", // eepic
                    "egameps", // egameps
                    "egothic", // bookhands
                    "egplot", // egplot
                    "eiad", // eiad
                    "ellipsis", // ellipsis
                    "elmath", // elmath
                    "em", // em
                    "embedfile", // oberdiek
                    "emp", // emp
                    "empheq", // mh
                    "empheq07", // mh
                    "endfloat", // endfloat
                    "endheads", // endheads
                    "endnotes", // ltxmisc
                    "endplate", // plates
                    "engpron", // engpron
                    "engrec", // engrec
                    "enumerate", // tools
                    "enumitem", // enumitem
                    "envbig", // envbig
                    "envlab", // envlab
                    "epic", // eepic
                    "epigraph", // epigraph
                    "epiolmec", // epiolmec
                    "epsdice", // epsdice
                    "epsfig", // graphics
                    "epstopdf", // oberdiek
                    "eqlist", // eqlist
                    "eqname", // eqname
                    "eqnarray", // eqnarray
                    "eqparbox", // eqparbox
                    "esdiff", // esdiff
                    "esindex", // bezos
                    "esint", // esint
                    "eso-pic", // eso-pic
                    "esvect", // esvect
                    "etaremune", // etaremune
                    "etex", // etex
                    "etruscan", // archaic
                    "eucal", // amsfonts
                    "euclide", // pst-eucl
                    "eufrak", // amsfonts
                    "euler", // euler
                    "eulervm", // eulervm
                    "euro", // euro
                    "eurofont", // eurofont
                    "europs", // eurofont
                    "eurosans", // eurosans
                    "eurosym", // eurosym
                    "euscript", // amsfonts
                    "everypage", // everypage
                    "everysel", // everysel
                    "everyshi", // everyshi
                    "evntlist", // calendar
                    "exaccent", // tipa
                    "example", // misc209
                    "examplep", // examplep
                    "excludeonly", // ltxmisc
                    "exercise", // exercise
                    "expdlist", // expdlist
                    "export", // export
                    "exscale", // base
                    "extarrows", // extarrows
                    "extdash", // ncctools
                    "extpfeil", // extpfeil
                    "extract", // extract
                    "extraipa", // tipa
                    "extramarks", // fancyhdr
                    "extsizes", // extsizes
                    "faktor", // faktor
                    "fancybox", // fancybox
                    "fancybox", // seminar
                    "fancyhdr", // fancyhdr
                    "fancynum", // fancynum
                    "fancyref", // fancyref
                    "fancyvrb", // fancyvrb
                    "feyn", // feyn
                    "feynmf", // feynmf
                    "feynmp", // feynmf
                    "fhACtitlepage", // thesis-titlepage-fhac
                    "figbib", // figbib
                    "figbib_add", // thesis-titlepage-fhac
                    "figcaps", // preprint
                    "figsize", // figsize
                    "filecontents", // filecontents
                    "fink", // fink
                    "fix-cm", // base
                    "fix2col", // carlisle
                    "fixfoot", // fixfoot
                    "fixltx2e", // base
                    "fixmath", // was
                    "fixme", // fixme
                    "fixseminar", // texpower
                    "flabels", // flabels
                    "flafter", // base
                    "flagderiv", // flagderiv
                    "fleqn", // base
                    "flexisym", // breqn
                    "flippdf", // flippdf
                    "float", // float
                    "floatflt", // floatflt
                    "floatpag", // sttools
                    "floatpagestyle", // floatrow
                    "floatrow", // floatrow
                    "flowfram", // flowfram
                    "flushend", // sttools
                    "fmp", // fmp
                    "fmtcount", // fmtcount
                    "fn2end", // ltxmisc
                    "fnbreak", // fnbreak
                    "fncychap", // fncychap
                    "fncylab", // ltxmisc
                    "fnpara", // ltxmisc
                    "fnpos", // yafoot
                    "foekfont", // foekfont
                    "foilhtml", // foilhtml
                    "fontdoc", // fontinst
                    "fontenc", // base
                    "fontsmpl", // tools
                    "footbib", // footbib
                    "footmisc", // footmisc
                    "footnote", // mdwtools
                    "footnpag", // footnpag
                    "forloop", // forloop
                    "formlett", // formlett
                    "formula", // formula
                    "formular", // formular
                    "fourier", // fourier
                    "fourier-orns", // fourier
                    "fp", // fp
                    "fp-addons", // fp
                    "fp-basic", // fp
                    "fp-eqn", // fp
                    "fp-eval", // fp
                    "fp-exp", // fp
                    "fp-pas", // fp
                    "fp-random", // fp
                    "fp-snap", // fp
                    "fp-trigo", // fp
                    "fp-upn", // fp
                    "fr-fancy", // floatrow
                    "framed", // ltxmisc
                    "frcursive", // frcursive
                    "frenchle", // frenchle
                    "ftcap", // ltxmisc
                    "ftnright", // tools
                    "fullblck", // fullblck
                    "fullpage", // preprint
                    "fullpict", // fullpict
                    "functan", // functan
                    "fvrb-ex", // fancyvrb
                    "fwlw", // ltxmisc
                    "g-brief", // g-brief
                    "g-brief2", // g-brief
                    "galois", // galois
                    "garamond", // psnfssx
                    "gastex", // gastex
                    "gatech-thesis-gloss", // gatech-thesis
                    "gatech-thesis-index", // gatech-thesis
                    "gatech-thesis-losa", // gatech-thesis
                    "gatech-thesis-patch", // gatech-thesis
                    "gauss", // gauss
                    "genmpage", // genmpage
                    "gensymb", // was
                    "geom", // geomsty
                    "geomar10", // geomsty
                    "geomar11", // geomsty
                    "geomar12", // geomsty
                    "geomart", // geomsty
                    "geombk10", // geomsty
                    "geombk11", // geomsty
                    "geombk12", // geomsty
                    "geombook", // geomsty
                    "geomenv", // geomsty
                    "geomeqns", // geomsty
                    "geometry", // geometry
                    "geomfig", // geomsty
                    "geomfnt", // geomsty
                    "geomindx", // geomsty
                    "geompsfi", // geomsty
                    "ginpenc", // ginpenc
                    "gloss", // gloss
                    "gloss_add", // thesis-titlepage-fhac
                    "glossary", // glossary
                    "gmdoc", // gmdoc
                    "gmiflink", // gmiflink
                    "gmutils", // gmutils
                    "gmverb", // gmverb
                    "gn-logic14", // logic
                    "gnuplottex", // gnuplottex
                    "go", // go
                    "grabhedr", // dialogl
                    "graphics", // graphics
                    "graphicx", // graphics
                    "graphicx-psmin", // graphicx-psmin
                    "graphpap", // base
                    "greek4cbc", // archaic
                    "greek6cbc", // archaic
                    "greekctr", // jknapltx
                    "grffile", // oberdiek
                    "grfpaste", // grfpaste
                    "grnumalt", // grnumalt
                    "guit", // GuIT
                    "hangcaption", // misc209
                    "hanging", // hanging
                    "hardmarg", // screenplay
                    "harpoon", // harpoon
                    "harvard", // harvard
                    "hbaw", // fancyvrb
                    "hcolor", // fancyvrb
                    "helvet", // psnfss
                    "hepparticles", // hepparticles
                    "hepunits", // hepunits
                    "hfoldsty", // hfoldsty
                    "hhline", // tools
                    "hhtensor", // hhtensor
                    "hieroglf", // archaic
                    "hieroglf", // hieroglf
                    "hilowres", // hilowres
                    "histogr", // histogr
                    "hlist", // calendar
                    "hml", // calendar
                    "hmonth", // calendar
                    "holtpolt", // jknapltx
                    "holtxdoc", // oberdiek
                    "hpplotsz", // calendar
                    "humanist", // bookhands
                    "huncial", // bookhands
                    "hvfloat", // hvfloat
                    "hvmaths", // hvmath
                    "hxt-bc", // hyper
                    "hypbmsec", // oberdiek
                    "hypcap", // oberdiek
                    "hypdestopt", // oberdiek
                    "hypdoc", // oberdiek
                    "hyper", // hyper
                    "hypernat", // ltxmisc
                    "hyperref", // hyperref
                    "hyperxmp", // hyperxmp
                    "hyphenat", // hyphenat
                    "icomma", // was
                    "icsv-dtx", // icsv
                    "ieeepes", // ieeepes
                    "ifdraft", // oberdiek
                    "ifmslide", // ifmslide
                    "ifmtarg", // ltxmisc
                    "ifoption", // amscls
                    "ifsym", // ifsym
                    "ifthen", // base
                    "imac", // imac
                    "import", // ltxmisc
                    "indentfirst", // tools
                    "index", // index
                    "infernce", // semantic
                    "infix-RPN", // pst-infixplot
                    "inlinebib", // inlinebib
                    "inputenc", // base
                    "inputenx", // oberdiek
                    "inslrmaj", // bookhands
                    "inslrmin", // bookhands
                    "invoice", // invoice
                    "ipa", // ipa
                    "ipalmacs", // wsuipa
                    "irv12", // iso10303
                    "isodate", // isodate
                    "isodateo", // isodate
                    "isorot", // isorot
                    "isotope", // isotope
                    "iwona", // iwona
                    "jneurosci", // jneurosci
                    "journal", // paper
                    "juraabbrev", // juraabbrev
                    "jurabase", // juramisc
                    "jurabib", // jurabib
                    "kalender", // kalender
                    "keystroke", // keystroke
                    "keyval", // graphics
                    "keywords", // progkeys
                    "kix", // ltxmisc
                    "klucite", // kluwer
                    "kluedit", // kluwer
                    "klufloa", // kluwer
                    "klulist", // kluwer
                    "klumac", // kluwer
                    "klumath", // kluwer
                    "klumono", // kluwer
                    "klunote", // kluwer
                    "kluopen", // kluwer
                    "klups", // kluwer
                    "kluref", // kluwer
                    "klusec", // kluwer
                    "klutab", // kluwer
                    "kvoptions", // oberdiek
                    "l3basics", // expl3
                    "l3chk", // expl3
                    "l3expan", // expl3
                    "l3int", // expl3
                    "l3io", // expl3
                    "l3names", // expl3
                    "l3precom", // expl3
                    "l3prop", // expl3
                    "l3quark", // expl3
                    "l3seq", // expl3
                    "l3tlp", // expl3
                    "l3toks", // expl3
                    "la", // fundus
                    "labelcas", // labelcas
                    "labels", // labels
                    "lambda", // skak
                    "lamsarrow", // pb-diagram
                    "lastpage", // lastpage
                    "latexsym", // base
                    "layout", // tools
                    "layouts", // layouts
                    "lazylist", // lazylist
                    "lblchng1", // ednotes
                    "lcd", // lcd
                    "lcg", // lcg
                    "ledarab", // ledmac
                    "ledmac", // ledmac
                    "ledpar", // ledmac
                    "ledparpatch", // ledmac
                    "ledpatch", // ledmac
                    "leftidx", // leftidx
                    "leqno", // base
                    "letter", // base
                    "letterspace", // microtype
                    "lettrine", // lettrine
                    "lewis", // lewis
                    "lexikon", // lexikon
                    "lfp", // fp
                    "lhelp", // lhelp
                    "ligature", // semantic
                    "limap", // limap
                    "linearA", // linearA
                    "linearb", // archaic
                    "lineno", // lineno
                    "lingmacros", // tree-dvips
                    "linguex", // linguex
                    "linguho", // linguex
                    "linsys", // ltxmisc
                    "lipsum", // lipsum
                    "listbib", // listbib
                    "listing", // ltxmisc
                    "listings", // listings
                    "listliketab", // listliketab
                    "listofsymbols", // listofsymbols
                    "listpen", // floatrow
                    "lmodern", // lm
                    "localloc", // localloc
                    "logpap", // logpap
                    "logsys", // coordsys
                    "longtable", // tools
                    "lsc", // lsc
                    "lscape", // graphics
                    "lstdoc", // listings
                    "lstlang1", // listings
                    "lstlang2", // listings
                    "lstlang3", // listings
                    "lstmisc", // listings
                    "lstpatch", // listings
                    "ltablex", // ltablex
                    "ltabptch", // ltabptch
                    "ltgothic", // pclnfss
                    "ltugboat", // tugboat
                    "ltugcomn", // tugboat
                    "ltugproc", // tugboat
                    "ltxindex", // ltxindex
                    "ltxtable", // carlisle
                    "lucbmath", // psnfssx
                    "lucidabr", // psnfssx
                    "lucidbrb", // psnfssx
                    "lucidbry", // psnfssx
                    "lucmin", // psnfssx
                    "lucmtime", // psnfssx
                    "luctime", // psnfssx
                    "m-ch-de", // context
                    "m-ch-en", // context
                    "m-ch-nl", // context
                    "m-metapo", // context
                    "m-pictex", // context
                    "mafr", // mafr
                    "magaz", // ltxmisc
                    "mailing", // mailing
                    "makebox", // makebox
                    "makecell", // makecell
                    "makecmds", // makecmds
                    "makeglos", // makeglos
                    "makeidx", // base
                    "makeplot", // makeplot
                    "makerobust", // oberdiek
                    "manfnt", // manfnt
                    "manuscript", // manuscript
                    "manyfoot", // ncctools
                    "mapcodes", // mapcodes
                    "marginal", // sttools
                    "marginnote", // marginnote
                    "margins", // calendar
                    "marigold", // pclnfss
                    "marvosym", // marvosym
                    "mathbbol", // jknapltx
                    "mathcomp", // mathcomp
                    "mathdesign", // mathdesign
                    "mathenv", // mdwtools
                    "mathpazo", // psnfss
                    "mathpple", // psnfss
                    "mathptm", // psnfss
                    "mathptmx", // psnfss
                    "mathrsfs", // jknapltx
                    "mathscinet", // amscls
                    "mathstyle", // breqn
                    "mathtools", // mh
                    "maybemath", // maybemath
                    "mboxfill", // ncctools
                    "mcaption", // mcaption
                    "mceinleger", // mceinleger
                    "mcite", // mcite
                    "mdbch", // mathdesign/mdbch
                    "mdput", // mathdesign/mdput
                    "mdugm", // mathdesign/mdugm
                    "mdwlist", // mdwtools
                    "mdwmath", // mdwtools
                    "mdwtab", // mdwtools
                    "memhfixc", // memoir
                    "mempatch", // memoir
                    "menu", // menu
                    "menus", // dialogl
                    "metainfo", // sauerj
                    "method", // method
                    "metre", // metre
                    "mff", // mff
                    "mflogo", // mflogo
                    "mfparptc", // ednotes
                    "mfparxsp", // ednotes
                    "mftinc", // mftinc
                    "mhchem", // mhchem
                    "mhequ", // mhequ
                    "mhs", // mhs
                    "mhsetup", // mh
                    "microtype", // microtype
                    "midfloat", // sttools
                    "midpage", // ltxmisc
                    "miller", // miller
                    "minimum", // tableaux
                    "miniplot", // miniplot
                    "minitoc", // minitoc
                    "minitoc-hyper", // hyperref
                    "minutes", // minutes
                    "mitpress", // ltxmisc
                    "mla", // mla-paper
                    "mltex", // mltex
                    "moderncvcompatibility", // moderncv
                    "moderncvstylecasual", // moderncv
                    "moderncvstyleclassic", // moderncv
                    "moderncvstyleempty", // moderncv
                    "modroman", // modroman
                    "monthly", // calendar
                    "morefloats", // ltxmisc
                    "morehelp", // morehelp
                    "moresize", // moresize
                    "moreverb", // moreverb
                    "morse", // morse
                    "movie15", // movie15
                    "mparhack", // mparhack
                    "mpgmpar", // minipage-marginpar
                    "mpmulti", // ppower4
                    "msc", // msc
                    "msg", // msg
                    "mslapa", // mslapa
                    "mtcmess", // minitoc
                    "mtcoff", // minitoc
                    "mtcpatchmem", // minitoc
                    "mtgreek", // mtgreek
                    "mtimes", // psnfssx
                    "multibbl", // multibbl
                    "multibib", // multibib
                    "multibox", // misc209
                    "multicap", // multicap
                    "multicol", // tools
                    "multienum", // multenum
                    "multimedia", // beamer/multimedia
                    "multimediasymbols", // beamer/multimedia
                    "multind", // misc209
                    "multiply", // bez123
                    "multirow", // multirow
                    "multitoc", // multitoc
                    "mwrite", // mwrite
                    "mxd", // mxd
                    "mxedruli", // mxedruli
                    "my-title", // uaclasses
                    "mycomplexity", // complexity
                    "mydoc", // easy
                    "mynormal", // germbib
                    "n-thb", // newthm
                    "n-thbno", // newthm
                    "n-thc", // newthm
                    "n-thcb", // newthm
                    "n-thcbno", // newthm
                    "n-thcno", // newthm
                    "n-thm", // newthm
                    "n-thmb", // newthm
                    "n-thmbno", // newthm
                    "n-thmno", // newthm
                    "n-thp", // newthm
                    "n-thpno", // newthm
                    "nabatean", // archaic
                    "nameref", // hyperref
                    "natbib", // natbib
                    "nath", // nath
                    "nbaseprt", // numprint
                    "nccbbb", // ncctools
                    "nccbiblist", // ncclatex
                    "nccboxes", // ncctools
                    "ncccomma", // ncctools
                    "ncccropbox", // ncctools
                    "ncccropmark", // ncctools
                    "nccdefaults", // ncclatex
                    "nccfancyhdr", // ncctools
                    "nccfloats", // ncctools
                    "nccfoots", // ncctools
                    "ncchdr", // ncclatex
                    "nccheadings", // ncclatex
                    "nccindex", // ncclatex
                    "ncclatex", // ncclatex
                    "nccltrus", // ncclatex
                    "nccmath", // ncctools
                    "nccold", // ncclatex
                    "nccparskip", // ncctools
                    "nccpic", // ncctools
                    "nccrules", // ncctools
                    "nccsect", // ncctools
                    "nccsections", // ncclatex
                    "nccstretch", // ncctools
                    "ncctheorems", // ncclatex
                    "nccthm", // ncctools
                    "ncctitle", // ncclatex
                    "ncctitlepage", // ncclatex
                    "needspace", // ltxmisc
                    "newalg", // newalg
                    "newcent", // psnfss
                    "newfile", // newfile
                    "newlfont", // base
                    "newthm", // newthm
                    "newvbtm", // newvbtm
                    "nextpage", // ltxmisc
                    "nicefrac", // units
                    "niceframe", // niceframe
                    "nohyperref", // hyperref
                    "noitcrul", // noitcrul
                    "nolbreaks", // ltxmisc
                    "nomencl", // nomencl
                    "nomentbl", // nomentbl
                    "nonfloat", // nonfloat
                    "nopageno", // carlisle
                    "notes", // notes
                    "notoccite", // ltxmisc
                    "nowtoaux", // volumes
                    "npsfont", // seminar
                    "nrc1", // nrc
                    "nrc2", // nrc
                    "nrcdoc", // nrc
                    "ntabbing", // ntabbing
                    "ntheorem", // ntheorem
                    "ntheorem-hyper", // hyperref
                    "numline", // numline
                    "numprint", // numprint
                    "numprint032", // numprint
                    "oands", // archaic
                    "obox", // slidenotes
                    "ocr", // ocr-latex
                    "oesch", // oesch
                    "olabels", // labels
                    "oldgerm", // mfnfss
                    "oldlfont", // base
                    "oldprsn", // archaic
                    "oldstyle", // oldstyle
                    "onlyamsmath", // onlyamsmath
                    "opcit", // opcit
                    "openbib", // base
                    "optional", // ltxmisc
                    "optparams", // sauerj
                    "ot1var", // psnfssx
                    "othello", // othello
                    "oubraces", // ltxmisc
                    "outline", // outline
                    "outliner", // outliner
                    "overcite", // cite
                    "overpic", // overpic
                    "overword", // calendar
                    "oxford", // oxford
                    "oz", // objectz
                    "pacioli", // pacioli
                    "pageno", // pageno
                    "pagenote", // pagenote
                    "pagepc", // refman
                    "pageranges", // inlinebib
                    "pagesel", // oberdiek
                    "palatino", // psnfss
                    "pap", // skak
                    "paper", // paper
                    "papercdcase", // papercdcase
                    "paralist", // paralist
                    "parallel", // parallel
                    "parboxx", // jknapltx
                    "parcolumns", // sauerj
                    "paresse", // paresse
                    "parrun", // parrun
                    "parskip", // ltxmisc
                    "patchcmd", // patchcmd
                    "path", // ltxmisc
                    "pauldoc", // pauldoc
                    "pause", // ppower4
                    "pawpict", // pawpict
                    "pb-diagram", // pb-diagram
                    "pb-lams", // pb-diagram
                    "pb-xy", // pb-diagram
                    "pbox", // pbox
                    "pbsi", // brushscr
                    "pcatcode", // amscls
                    "pcode", // plweb
                    "pdfcolfoot", // oberdiek
                    "pdfcolmk", // oberdiek
                    "pdfcprot", // pdfcprot
                    "pdflscape", // oberdiek
                    "pdfnotiz", // dvdcoll
                    "pdfpages", // pdfpages
                    "pdfscreen", // pdfscreen
                    "pdfslide", // pdfslide
                    "pdfsync", // pdfsync
                    "pdftricks", // pdftricks
                    "pdfwin", // pdfwin
                    "perltex", // perltex
                    "permute", // permute
                    "perpage", // bigfoot
                    "pfnote", // yafoot
                    "pgf", // pgf/basiclayer
                    "pgfarrows", // pgf/compatibility
                    "pgfautomata", // pgf/compatibility
                    "pgfbaseimage", // pgf/basiclayer
                    "pgfbaselayers", // pgf/basiclayer
                    "pgfbasepatterns", // pgf/basiclayer
                    "pgfbaseplot", // pgf/basiclayer
                    "pgfbaseshapes", // pgf/basiclayer
                    "pgfbasesnakes", // pgf/basiclayer
                    "pgfcomp-version-0-65", // pgf/compatibility
                    "pgfcore", // pgf/basiclayer
                    "pgffor", // pgf/utilities
                    "pgfheaps", // pgf/compatibility
                    "pgflibraryarrows", // pgf/compatibility
                    "pgflibraryautomata", // pgf/compatibility
                    "pgflibraryplothandlers", // pgf/compatibility
                    "pgflibraryplotmarks", // pgf/compatibility
                    "pgflibraryshapes", // pgf/compatibility
                    "pgflibrarysnakes", // pgf/compatibility
                    "pgflibrarytikzbackgrounds", // pgf/compatibility
                    "pgflibrarytikztrees", // pgf/compatibility
                    "pgfnodes", // pgf/compatibility
                    "pgfpages", // pgf/utilities
                    "pgfpict2e", // pgf/frontendlayer
                    "pgfrcs", // pgf/utilities
                    "pgfreadexternal", // pgf/utilities
                    "pgfshade", // pgf/compatibility
                    "pgfsys", // pgf/systemlayer
                    "pgfwriteexternal", // pgf/utilities
                    "pgothic", // bookhands
                    "phaistos", // phaistos
                    "phoenician", // archaic
                    "phonetic", // phonetic
                    "photo", // photo
                    "picinpar", // picinpar
                    "pict2e", // pict2e
                    "pictex2", // pictex2
                    "picture", // oberdiek
                    "pifont", // psnfss
                    "pl", // plweb
                    "placeins", // placeins
                    "plain", // carlisle
                    "plates", // plates
                    "play", // play
                    "pmboxdraw", // oberdiek
                    "pmgraph", // pmgraph
                    "pndraw", // petri-nets
                    "pnets", // petri-nets
                    "pntext", // petri-nets
                    "poemscol", // poemscol
                    "polyglot", // polyglot
                    "polynom", // polynom
                    "polytable", // polytable
                    "portland", // misc209
                    "powerdot-aggie", // powerdot
                    "powerdot-bframe", // powerdot
                    "powerdot-ciment", // powerdot
                    "powerdot-default", // powerdot
                    "powerdot-elcolors", // powerdot
                    "powerdot-fyma", // powerdot
                    "powerdot-horatio", // powerdot
                    "powerdot-husky", // powerdot
                    "powerdot-ikeda", // powerdot
                    "powerdot-jefka", // powerdot
                    "powerdot-klope", // powerdot
                    "powerdot-paintings", // powerdot
                    "powerdot-pazik", // powerdot
                    "powerdot-sailor", // powerdot
                    "powerdot-simple", // powerdot
                    "powerdot-tycja", // powerdot
                    "powerdot-upen", // powerdot
                    "pp4link", // ppower4
                    "pp4slide", // ppower4
                    "prelim2e", // prelim2e
                    "prettyref", // prettyref
                    "preview", // preview
                    "printlen", // ltxmisc
                    "printsudoku", // sudokubundle
                    "prnthyph", // cbcoptic
                    "proba", // ltxmisc
                    "probsoln", // probsoln
                    "proc", // base
                    "procIAGssymp", // procIAGssymp
                    "processkv", // sauerj
                    "program", // program
                    "programs", // progkeys
                    "progress", // progress
                    "proof", // lkproof
                    "protosem", // archaic
                    "ps-trees", // linguex
                    "psboxit", // misc209
                    "pseudocode", // pseudocode
                    "psfont", // altfont
                    "psfrag", // psfrag
                    "psfragx", // psfragx
                    "psgo", // psgo
                    "pslatex", // pslatex
                    "pspicture", // pspicture
                    "pst-3d", // pst-3d
                    "pst-3dplot", // pst-3dplot
                    "pst-all", // pstricks
                    "pst-bar", // pst-bar
                    "pst-barcode", // pst-barcode
                    "pst-blur", // pst-blur
                    "pst-circ", // pst-circ
                    "pst-coil", // pst-coil
                    "pst-dbicons", // pst-dbicons
                    "pst-eps", // pst-eps
                    "pst-eucl", // pst-eucl
                    "pst-fill", // pst-fill
                    "pst-fr3d", // pst-fr3d
                    "pst-func", // pst-func
                    "pst-ghsb", // pst-ghsb
                    "pst-gr3d", // pst-gr3d
                    "pst-grad", // pst-grad
                    "pst-infixplot", // pst-infixplot
                    "pst-jtree", // pst-jtree
                    "pst-key", // pstricks
                    "pst-labo", // pst-labo
                    "pst-lens", // pst-lens
                    "pst-light3d", // pst-light3d
                    "pst-map2d", // pst-geo
                    "pst-map2dII", // pst-geo
                    "pst-map3d", // pst-geo
                    "pst-map3dII", // pst-geo
                    "pst-math", // pst-math
                    "pst-node", // pstricks
                    "pst-optic", // pst-optic
                    "pst-osci", // pst-osci
                    "pst-pdf", // pst-pdf
                    "pst-pdgr", // pst-pdgr
                    "pst-plot", // pstricks
                    "pst-poly", // pst-poly
                    "pst-slpe", // pst-slpe
                    "pst-text", // pst-text
                    "pst-tree", // pstricks
                    "pst-uml", // pst-uml
                    "pst-vue3d", // pst-vue3d
                    "pst-xkey", // xkeyval
                    "pstcol", // pstricks
                    "pstfp", // bardiag
                    "pstricks", // pstricks
                    "pstricks-add", // pstricks-add
                    "pvscript", // fundus
                    "pxfonts", // pxfonts
                    "qbookman", // tex-gyre
                    "qcm", // qcm
                    "qpalatin", // tex-gyre
                    "qsymbols", // qsymbols
                    "qtimes", // tex-gyre
                    "qtree", // qtree
                    "quotchap", // quotchap
                    "ragged2e", // ragged2e
                    "randbild", // randbild
                    "randtext", // randtext
                    "rawfonts", // tools
                    "rccol", // rccol
                    "rcs", // rcs
                    "rcsinfo", // rcsinfo
                    "rectopma", // rectopma
                    "refcheck", // refcheck
                    "refcount", // oberdiek
                    "refstyle", // refstyle
                    "regcount", // regcount
                    "register", // register
                    "relabel", // computational-complexity
                    "relenc", // relenc
                    "relinput", // stack
                    "relsize", // ltxmisc
                    "remreset", // carlisle
                    "repeatindex", // repeatindex
                    "report", // base
                    "reserved", // semantic
                    "revsymb", // revtex
                    "rkeyval", // amscls
                    "rkvbeta", // amscls
                    "rmpage", // rmpage
                    "robustcommand", // robustcommand
                    "robustglossary", // robustindex
                    "robustindex", // robustindex
                    "romanneg", // ltxmisc
                    "romannum", // romannum
                    "rotating", // rotating
                    "rotfloat", // rotfloat
                    "rotpages", // rotpages
                    "rotunda", // bookhands
                    "rsc", // rsc
                    "rsphrase", // mhchem
                    "rst", // rst
                    "rtkinenc", // rtkinenc
                    "runic", // archaic
                    "rustic", // bookhands
                    "sans", // jknapltx
                    "sansmath", // ltxmisc
                    "sarabian", // archaic
                    "savefnmark", // savefnmark
                    "savesym", // savesym
                    "savetrees", // savetrees
                    "sbbm", // sauterfonts
                    "scale", // scale
                    "scalebar", // scalebar
                    "scalefnt", // carlisle
                    "schedule", // schedule
                    "science", // scientificpaper
                    "scraddr", // koma-script
                    "scrdate", // koma-script
                    "script10", // script
                    "script11", // script
                    "script12", // script
                    "script18", // script
                    "scrkbase", // koma-script
                    "scrlfile", // koma-script
                    "scrpage", // koma-script
                    "scrpage2", // koma-script
                    "scrtime", // koma-script
                    "secdot", // ltxmisc
                    "section", // ltxmisc
                    "sectionbox", // sectionbox
                    "sectsty", // sectsty
                    "selectp", // ltxmisc
                    "sem-a4", // seminar
                    "sem-page", // seminar
                    "semantic", // semantic
                    "semcolor", // seminar
                    "semhelv", // seminar
                    "seminar", // seminar
                    "semioneside", // semioneside
                    "semlayer", // seminar
                    "semlcmss", // seminar
                    "semrot", // seminar
                    "semtrans", // jknapltx
                    "sepnum", // ltxmisc
                    "seqsplit", // seqsplit
                    "setdim", // newlfm
                    "sets", // vhistory
                    "setspace", // setspace
                    "settobox", // oberdiek
                    "sexscale", // sauterfonts
                    "sf298", // sf298
                    "sffdumb", // sffms
                    "sffsmart", // sffms
                    "sgame", // sgame
                    "sgamevar", // sgame
                    "sgmlcmpt", // jknapltx
                    "shadbox", // shadbox
                    "shadbox1", // shadbox
                    "shadethm", // shadethm
                    "shadow", // ltxmisc
                    "shortlst", // shortlst
                    "shorttoc", // shorttoc
                    "shortvrb", // base
                    "showdim", // showdim
                    "showexpl", // showexpl
                    "showframe", // eso-pic
                    "showidx", // base
                    "showkeys", // tools
                    "showkeysff", // chemcono
                    "showlabels", // showlabels
                    "showtags", // ltxmisc
                    "shrthand", // semantic
                    "sidebars", // talk
                    "sidecap", // sidecap
                    "sig", // fax
                    "sistyle", // SIstyle
                    "skak", // skak
                    "skull", // skull
                    "slantsc", // slantsc
                    "slashbox", // slashbox
                    "slashed", // carlisle
                    "slides", // base
                    "slidesec", // seminar
                    "smallcap", // taupin
                    "smalltableof", // smalltableof
                    "smartmn", // jknapltx
                    "smartref", // smartref
                    "smfenum", // smflatex
                    "smfthm", // smflatex
                    "snapshot", // snapshot
                    "solvesudoku", // sudokubundle
                    "somedefs", // tools
                    "soul", // soul
                    "sparklines", // sparklines
                    "sphack", // ltxmisc
                    "splitbib", // splitbib
                    "splitidx", // splitindex
                    "sprite", // sprite
                    "sqrcaps", // bookhands
                    "srcltx", // srcltx
                    "srctex", // srcltx
                    "sseq", // sseq
                    "ssqquote", // ssqquote
                    "stabular", // sttools
                    "stack", // stack
                    "stackrel", // oberdiek
                    "stamm", // umrand
                    "startrek", // fundus
                    "statex", // ltxmisc
                    "statistik", // statistik
                    "stdclsdv", // stdclsdv
                    "stdpage", // stdpage
                    "stepv13", // iso10303
                    "stfloats", // sttools
                    "stmaryrd", // stmaryrd
                    "strukdoc", // struktex
                    "struktex", // struktex
                    "struktxf", // struktex
                    "struktxp", // struktex
                    "struts", // umrand
                    "subeqn", // subeqn
                    "subeqnarray", // subeqnarray
                    "subfig", // subfig
                    "subfigmat", // ltxmisc
                    "subfigure", // subfigure
                    "subfloat", // subfloat
                    "sublabel", // preprint
                    "substr", // substr
                    "sudoku", // sudoku
                    "suetterl", // fundus
                    "suffix", // bigfoot
                    "supertabular", // supertabular
                    "sverb", // mdwtools
                    "svgcolor", // svgcolor
                    "svn", // svn
                    "svninfo", // svninfo
                    "svnkw", // svn-multi
                    "swimgraf", // swimgraf
                    "syntax", // mdwtools
                    "syntonly", // base
                    "syntrace", // syntrace
                    "synttree", // synttree
                    "t-angles", // t-angles
                    "t1enc", // base
                    "tableau", // tableaux
                    "tabls", // ltxmisc
                    "tabto", // tabto-ltx
                    "tabularht", // oberdiek
                    "tabularkv", // oberdiek
                    "tabularx", // tools
                    "tabulary", // tabulary
                    "tabvar", // tabvar
                    "tccompat", // jknapltx
                    "tcldoc", // tcldoc
                    "tclldoc", // tcldoc
                    "tdiagram", // semantic
                    "technics", // technics
                    "tengwarscript", // tengwarscript
                    "tensind", // bezos
                    "tensor", // tensor
                    "texlogos", // texlogos
                    "texmate", // texmate
                    "texnansi", // ly1
                    "texpause", // ppower4
                    "texpower", // texpower
                    "texshade", // texshade
                    "texsort", // sttools
                    "textarea", // ncctools
                    "textcase", // textcase
                    "textcmds", // amscls
                    "textcomp", // base
                    "textfit", // textfit
                    "textopo", // textopo
                    "textpathmp", // textpath
                    "textpos", // textpos
                    "tgbonum", // tex-gyre
                    "tgothic", // bookhands
                    "tgpagella", // tex-gyre
                    "tgschola", // tex-gyre
                    "tgtermes", // tex-gyre
                    "thb", // tools
                    "thc", // tools
                    "thcb", // tools
                    "thcc", // computational-complexity
                    "theorem", // tools
                    "thm", // tools
                    "thmb", // tools
                    "thp", // tools
                    "threeparttable", // ltxmisc
                    "thrmappendix", // ltxmisc
                    "thumb", // thumb
                    "ticket", // ticket
                    "tikz", // pgf/frontendlayer
                    "times", // psnfss
                    "timesht", // calendar
                    "timesnew", // pclnfss
                    "timetabl", // calendar
                    "timing", // timing
                    "tipa", // tipa
                    "tipx", // tipa
                    "titlefoot", // titlefoot
                    "titleref", // ltxmisc
                    "titlesec", // titlesec
                    "titletoc", // titlesec
                    "titling", // titling
                    "tmmaths", // tmmath
                    "tocbibind", // tocbibind
                    "tocenter", // ncctools
                    "tocloft", // tocloft
                    "tocvsec2", // tocvsec2
                    "todo", // todo
                    "tokenizer", // tokenizer
                    "toklist", // williams
                    "tone", // tipa
                    "toolbox", // toolbox
                    "topcapt", // ltxmisc
                    "topfloat", // topfloat
                    "topsection", // ncctools
                    "totpages", // totpages
                    "tplists", // texpower
                    "tppstcol", // texpower
                    "tpsem-a4", // texpower
                    "tpslifonts", // tpslifonts
                    "trace", // tools
                    "tracefnt", // base
                    "tracking", // tracking
                    "trajan", // trajan
                    "transparent", // oberdiek
                    "tree-dvips", // tree-dvips
                    "trfsigns", // trfsigns
                    "trig", // graphics
                    "trsym", // trsym
                    "truncate", // ltxmisc
                    "twcal", // fundus
                    "twoopt", // oberdiek
                    "twoup", // twoup
                    "txfonts", // txfonts
                    "type1cm", // type1cm
                    "type1ec", // cm-super
                    "typearea", // koma-script
                    "typedref", // typedref
                    "typehtml", // carlisle
                    "typogrid", // typogrid
                    "ua-title", // uaclasses
                    "ucs", // ucs
                    "ucshyper", // ucs
                    "ucsutils", // ucs
                    "ugarite", // archaic
                    "uhrzeit", // uhrzeit
                    "uiucthesis", // uiucthesis
                    "ulem", // ltxmisc
                    "ulsy", // ulsy
                    "uml", // uml
                    "umlaute", // umlaute
                    "umoline", // umoline
                    "umrand", // umrand
                    "uncial", // bookhands
                    "underlin", // underlin
                    "underscore", // ltxmisc
                    "undertilde", // undertilde
                    "uni", // universa
                    "units", // units
                    "unitsdef", // unitsdef
                    "univers", // pclnfss
                    "universal", // bayer
                    "upgreek", // was
                    "upquote", // upquote
                    "upref", // amscls
                    "url", // ltxmisc
                    "usbib", // stellenbosch
                    "ushort", // ushort
                    "usnomencl", // stellenbosch
                    "ussummary", // stellenbosch
                    "usthesis", // stellenbosch
                    "ustitle", // stellenbosch
                    "utopia", // psnfss
                    "va", // fundus
                    "variations", // variations
                    "varindex", // varindex
                    "varioref", // tools
                    "varsects", // taupin
                    "varvbtm", // newvbtm
                    "varwidth", // ltxmisc
                    "vector", // vector
                    "verbasef", // ltxmisc
                    "verbatim", // tools
                    "verbdef", // ltxmisc
                    "verbfwr", // examplep
                    "verse", // verse
                    "version", // ltxmisc
                    "versions", // versions
                    "vertbars", // ltxmisc
                    "vhistory", // vhistory
                    "viking", // archaic
                    "vmargin", // vmargin
                    "volumes", // volumes
                    "vowel", // tipa
                    "vpe", // vpe
                    "vplref", // lineno
                    "vrbexin", // ltxmisc
                    "vrsion", // vrsion
                    "vruler", // ltxmisc
                    "wallpaper", // wallpaper
                    "warning", // warning
                    "warpcol", // warpcol
                    "wasysym", // wasysym
                    "watermark", // ncctools
                    "wordlike", // wordlike
                    "wrapfig", // wrapfig
                    "wrapft", // ptptex
                    "xcolor", // xcolor
                    "xcomment", // seminar
                    "xdoc2", // xdoc
                    "xfrac", // xfrac
                    "xifthen", // xifthen
                    "xkeyval", // xkeyval
                    "xkvltxp", // xkeyval
                    "xkvview", // xkeyval
                    "xmpincl", // xmpincl
                    "xmpmulti", // beamer/multimedia
                    "xq", // xq
                    "xr", // tools
                    "xr-hyper", // hyperref
                    "xspace", // tools
                    "xt_capts", // xtcapts
                    "xtab", // xtab
                    "xucuri", // mxedruli
                    "xxcolor", // pgf/utilities
                    "xyling", // xyling
                    "xytree", // xytree
                    "yearly", // calendar
                    "yfonts", // yfonts
                    "yhmath", // yhmath
                    "young", // jknapltx
                    "youngtab", // youngtab
                    "yplan", // yplan
                    "zahl2string", // sauerj
                    "zed-csp", // zed-csp
                    "zefonts", // zefonts
                    "ziffer", // ltxmisc
                    "zref", // oberdiek
                    "zref-abspage", // oberdiek
                    "zref-base", // oberdiek
                    "zref-counter", // oberdiek
                    "zref-dotfill", // oberdiek
                    "zref-hyperref", // oberdiek
                    "zref-lastpage", // oberdiek
                    "zref-perpage", // oberdiek
                    "zref-savepos", // oberdiek
                    "zref-titleref", // oberdiek
                    "zref-totpages", // oberdiek
                    "zref-user", // oberdiek
                    "zref-xr" // oberdiek
            };

    /**
     * {@inheritDoc}
     * 
     * @see org.extex.builder.latex.artifact.latex.MacroWithArgs#expand(org.extex.builder.latex.artifact.latex.LatexReader,
     *      org.extex.builder.latex.DependencyNet,
     *      org.extex.builder.latex.artifact.Artifact, java.lang.String,
     *      java.lang.String)
     */
    @Override
    public void expand(LatexReader reader, DependencyNet net,
            Artifact artifact, String opt, String arg) throws IOException {

        for (String p : arg.split(",")) {
            p = p.trim();
            File f = net.searchFile(arg, //
                net.getParameters().getLatexExtensions(), artifact.getFile());
            if (f == null) {
                warn(p, net.getLogger());
            } else {
                Artifact a = new Artifact(f);
                net.addArtifact(a);
                net.getTarget().dependsOn(a);

                net.setAtLetter(true);
                net.analyzeLaTeX(a);
                net.setAtLetter(false);
            }
        }
    }

    /**
     * Possibly issue a warning that the package is knot known.
     * 
     * @param p the name of the package
     * @param logger the logger
     */
    private void warn(String p, Logger logger) {

        for (String s : PACKAGES) {
            if (p.equals(s)) {
                return;
            }
        }
        logger.info(Message.get("usepackage.ignored", p));
        return;
    }

}
